
# Autogenerated by mlir-tblgen; don't manually edit.

from ._ods_common import _cext as _ods_cext
from ._ods_common import extend_opview_class as _ods_extend_opview_class, segmented_accessor as _ods_segmented_accessor, equally_sized_accessor as _ods_equally_sized_accessor, get_default_loc_context as _ods_get_default_loc_context, get_op_result_or_value as _get_op_result_or_value, get_op_results_or_values as _get_op_results_or_values
_ods_ir = _ods_cext.ir

try:
  from . import _quake_ops_ext as _ods_ext_module
except ImportError:
  _ods_ext_module = None

import builtins


@_ods_cext.register_dialect
class _Dialect(_ods_ir.Dialect):
  DIALECT_NAMESPACE = "quake"
  pass


@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class DiscriminateOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.discriminate"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, measurement, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(measurement))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def measurement(self):
    return self.operation.operands[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class ExpPauliOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.exp_pauli"

  _ODS_REGIONS = (0, True)

  def __init__(self, parameter, qubits, pauli, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(parameter))
    operands.append(_get_op_result_or_value(qubits))
    operands.append(_get_op_result_or_value(pauli))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameter(self):
    return self.operation.operands[0]

  @builtins.property
  def qubits(self):
    return self.operation.operands[1]

  @builtins.property
  def pauli(self):
    return self.operation.operands[2]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class HOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.h"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class MxOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.mx"

  _ODS_REGIONS = (0, True)

  def __init__(self, measOut, wires, targets, *, registerName=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if registerName is not None: attributes["registerName"] = (registerName if (
        issubclass(type(registerName), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('StrAttr')) else
          _ods_ir.AttrBuilder.get('StrAttr')(registerName, context=_ods_context))
    results.append(measOut)
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def targets(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def registerName(self):
    if "registerName" not in self.operation.attributes:
      return None
    return _ods_ir.StringAttr(self.operation.attributes["registerName"])

  @registerName.setter
  def registerName(self, value):
    if value is not None:
      self.operation.attributes["registerName"] = value
    elif "registerName" in self.operation.attributes:
      del self.operation.attributes["registerName"]

  @registerName.deleter
  def registerName(self):
    del self.operation.attributes["registerName"]

  @builtins.property
  def measOut(self):
    return self.operation.results[0]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 2 + 1
    return self.operation.results[1:1 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class MyOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.my"

  _ODS_REGIONS = (0, True)

  def __init__(self, measOut, wires, targets, *, registerName=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if registerName is not None: attributes["registerName"] = (registerName if (
        issubclass(type(registerName), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('StrAttr')) else
          _ods_ir.AttrBuilder.get('StrAttr')(registerName, context=_ods_context))
    results.append(measOut)
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def targets(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def registerName(self):
    if "registerName" not in self.operation.attributes:
      return None
    return _ods_ir.StringAttr(self.operation.attributes["registerName"])

  @registerName.setter
  def registerName(self, value):
    if value is not None:
      self.operation.attributes["registerName"] = value
    elif "registerName" in self.operation.attributes:
      del self.operation.attributes["registerName"]

  @registerName.deleter
  def registerName(self):
    del self.operation.attributes["registerName"]

  @builtins.property
  def measOut(self):
    return self.operation.results[0]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 2 + 1
    return self.operation.results[1:1 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class MzOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.mz"

  _ODS_REGIONS = (0, True)

  def __init__(self, measOut, wires, targets, *, registerName=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if registerName is not None: attributes["registerName"] = (registerName if (
        issubclass(type(registerName), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('StrAttr')) else
          _ods_ir.AttrBuilder.get('StrAttr')(registerName, context=_ods_context))
    results.append(measOut)
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def targets(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def registerName(self):
    if "registerName" not in self.operation.attributes:
      return None
    return _ods_ir.StringAttr(self.operation.attributes["registerName"])

  @registerName.setter
  def registerName(self, value):
    if value is not None:
      self.operation.attributes["registerName"] = value
    elif "registerName" in self.operation.attributes:
      del self.operation.attributes["registerName"]

  @registerName.deleter
  def registerName(self):
    del self.operation.attributes["registerName"]

  @builtins.property
  def measOut(self):
    return self.operation.results[0]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 2 + 1
    return self.operation.results[1:1 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class PhasedRxOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.phased_rx"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class R1Op(_ods_ir.OpView):
  OPERATION_NAME = "quake.r1"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class RxOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.rx"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class RyOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.ry"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class RzOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.rz"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class SOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.s"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class SwapOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.swap"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class TOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.t"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class U2Op(_ods_ir.OpView):
  OPERATION_NAME = "quake.u2"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class U3Op(_ods_ir.OpView):
  OPERATION_NAME = "quake.u3"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class XOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.x"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class YOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.y"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class ZOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.z"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, parameters, controls, targets, *, is_adj=None, negated_qubit_controls=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(parameters))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    if negated_qubit_controls is not None: attributes["negated_qubit_controls"] = (negated_qubit_controls if (
        issubclass(type(negated_qubit_controls), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseBoolArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseBoolArrayAttr')(negated_qubit_controls, context=_ods_context))
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def parameters(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def targets(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class AllocaOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.alloca"

  _ODS_REGIONS = (0, True)

  def __init__(self, ref_or_vec, *, size=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    if size is not None: operands.append(_get_op_result_or_value(size))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(ref_or_vec)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def size(self):
    return None if len(self.operation.operands) < 1 else self.operation.operands[0]

  @builtins.property
  def ref_or_vec(self):
    return self.operation.results[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class ApplyOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.apply"

  _ODS_OPERAND_SEGMENTS = [-1,-1,-1,]

  _ODS_REGIONS = (0, True)

  def __init__(self, result, indirect_callee, controls, args, *, callee=None, is_adj=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_results_or_values(indirect_callee))
    operands.append(_get_op_results_or_values(controls))
    operands.append(_get_op_results_or_values(args))
    _ods_context = _ods_get_default_loc_context(loc)
    if callee is not None: attributes["callee"] = (callee if (
        issubclass(type(callee), _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('SymbolRefAttr')) else
          _ods_ir.AttrBuilder.get('SymbolRefAttr')(callee, context=_ods_context))
    if bool(is_adj): attributes["is_adj"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    results.extend(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def indirect_callee(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 0)
    return operand_range

  @builtins.property
  def controls(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 1)
    return operand_range

  @builtins.property
  def args(self):
    operand_range = _ods_segmented_accessor(
         self.operation.operands,
         self.operation.attributes["operand_segment_sizes"], 2)
    return operand_range

  @builtins.property
  def is_adj(self):
    return "is_adj" in self.operation.attributes

  @is_adj.setter
  def is_adj(self, value):
    if bool(value):
      self.operation.attributes["is_adj"] = _ods_ir.UnitAttr.get()
    elif "is_adj" in self.operation.attributes:
      del self.operation.attributes["is_adj"]

  @is_adj.deleter
  def is_adj(self):
    del self.operation.attributes["is_adj"]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class ComputeActionOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.compute_action"

  _ODS_REGIONS = (0, True)

  def __init__(self, compute, action, *, is_dagger=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(compute))
    operands.append(_get_op_result_or_value(action))
    _ods_context = _ods_get_default_loc_context(loc)
    if bool(is_dagger): attributes["is_dagger"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def compute(self):
    return self.operation.operands[0]

  @builtins.property
  def action(self):
    return self.operation.operands[1]

  @builtins.property
  def is_dagger(self):
    return "is_dagger" in self.operation.attributes

  @is_dagger.setter
  def is_dagger(self, value):
    if bool(value):
      self.operation.attributes["is_dagger"] = _ods_ir.UnitAttr.get()
    elif "is_dagger" in self.operation.attributes:
      del self.operation.attributes["is_dagger"]

  @is_dagger.deleter
  def is_dagger(self):
    del self.operation.attributes["is_dagger"]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class ConcatOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.concat"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, qbits, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(qbits))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def qbits(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class DeallocOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.dealloc"

  _ODS_REGIONS = (0, True)

  def __init__(self, reference, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(reference))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def reference(self):
    return self.operation.operands[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class ExtractRefOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.extract_ref"

  _ODS_REGIONS = (0, True)

  def __init__(self, ref, veq, rawIndex, *, index=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(veq))
    if index is not None: operands.append(_get_op_result_or_value(index))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["rawIndex"] = (rawIndex if (
    issubclass(type(rawIndex), _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('I64Attr')) else
      _ods_ir.AttrBuilder.get('I64Attr')(rawIndex, context=_ods_context))
    results.append(ref)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def veq(self):
    return self.operation.operands[0]

  @builtins.property
  def index(self):
    return None if len(self.operation.operands) < 2 else self.operation.operands[1]

  @builtins.property
  def rawIndex(self):
    return _ods_ir.IntegerAttr(self.operation.attributes["rawIndex"])

  @rawIndex.setter
  def rawIndex(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["rawIndex"] = value

  @builtins.property
  def ref(self):
    return self.operation.results[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class FromControlOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.from_ctrl"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, ctrlbit, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(ctrlbit))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def ctrlbit(self):
    return self.operation.operands[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class NullWireOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.null_wire"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class RelaxSizeOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.relax_size"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, inputVec, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(inputVec))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def inputVec(self):
    return self.operation.operands[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class ResetOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.reset"

  _ODS_REGIONS = (0, True)

  def __init__(self, wires, targets, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(targets))
    _ods_context = _ods_get_default_loc_context(loc)
    results.extend(wires)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def targets(self):
    return self.operation.operands[0]

  @builtins.property
  def wires(self):
    _ods_variadic_group_length = len(self.operation.results) - 1 + 1
    return self.operation.results[0:0 + _ods_variadic_group_length]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class SinkOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.sink"

  _ODS_REGIONS = (0, True)

  def __init__(self, target, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(target))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def target(self):
    return self.operation.operands[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class SubVeqOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.subveq"

  _ODS_REGIONS = (0, True)

  def __init__(self, qsub, veq, low, high, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(veq))
    operands.append(_get_op_result_or_value(low))
    operands.append(_get_op_result_or_value(high))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(qsub)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def veq(self):
    return self.operation.operands[0]

  @builtins.property
  def low(self):
    return self.operation.operands[1]

  @builtins.property
  def high(self):
    return self.operation.operands[2]

  @builtins.property
  def qsub(self):
    return self.operation.results[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class ToControlOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.to_ctrl"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, qubit, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(qubit))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def qubit(self):
    return self.operation.operands[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class UnwrapOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.unwrap"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, ref_value, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(ref_value))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(result)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def ref_value(self):
    return self.operation.operands[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class VeqSizeOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.veq_size"

  _ODS_REGIONS = (0, True)

  def __init__(self, size, veq, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(veq))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(size)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def veq(self):
    return self.operation.operands[0]

  @builtins.property
  def size(self):
    return self.operation.results[0]

@_ods_cext.register_operation(_Dialect)
@_ods_extend_opview_class(_ods_ext_module)
class WrapOp(_ods_ir.OpView):
  OPERATION_NAME = "quake.wrap"

  _ODS_REGIONS = (0, True)

  def __init__(self, wire_value, ref_value, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(wire_value))
    operands.append(_get_op_result_or_value(ref_value))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(
      attributes=attributes, results=results, operands=operands,
      successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def wire_value(self):
    return self.operation.operands[0]

  @builtins.property
  def ref_value(self):
    return self.operation.operands[1]
